Description

Nowadays, almost every processor has more than one core. Therefore it becomes more and more important for languages to have

good support of concurrent and/or parallel computation. Currently Ruby supports concurrency mainly through high-level classes:

Thread, Queue, Mutex, Monitor, ConditionVariable.

This work is not colliding with plans for Ruby 3 (to provide an easy-to-use and safe concurrent abstraction to Ruby users). Following

proposals suggest several key low-level Ruby extensions which will allow those interested in these topics to create fast concurrency

abstractions (gems) for Ruby community, providing more choices and complementing the effort of Ruby 3. The proposed APIs are

not expected to be used for every day programming but rather by concurrency enthusiast.

This issue is intended to serve as an aggregator for other various proposals described in following issues.

Related issues:

Related to Ruby - Feature #12020: Documenting Ruby memory model Assigned

Related to Ruby - Feature #11539: Support explicit declaration of volatile in... Open

Related to Ruby - Feature #8259: Atomic attributes accessors Open

Related to Ruby - Feature #12021: Final instance variables Open

Related to Ruby - Feature #11541: Let attr_accessor, _reader & _writer return... Closed

History

#1 - 01/25/2016 07:18 PM - pitr.ch (Petr Chalupa)

I'll be adding or linking existing proposals gradually:

Documenting Ruby memory model

Volatile instance variables

Atomic instance variables

Final instance variables

Let Module.attr.* methods return symbols of the defined methods

Relaxing variable volatility/atomicity

I've tried to describe the intentions for Ruby 3 as best as I could, please correct the statement if it's inaccurate.

#2 - 01/25/2016 10:19 PM - Eregon (Benoit Daloze)

- Related to Feature #12020: Documenting Ruby memory model added

#3 - 01/25/2016 10:19 PM - Eregon (Benoit Daloze)

- Related to Feature #11539: Support explicit declaration of volatile instance variables added

#4 - 01/25/2016 10:19 PM - Eregon (Benoit Daloze)

- Related to Feature #8259: Atomic attributes accessors added

#5 - 01/25/2016 10:19 PM - Eregon (Benoit Daloze)

- Related to Feature #12021: Final instance variables added

#6 - 01/25/2016 10:20 PM - Eregon (Benoit Daloze)

- Related to Feature #11541: Let attr_accessor, _reader & _writer return symbols of the defined methods added

#7 - 01/27/2016 06:27 AM - ferdinandrosario@gmail.com (ferdinand rosario)

- Assignee changed from pitr.ch (Petr Chalupa) to matz (Yukihiro Matsumoto)
https://bugs.ruby-lang.org/issues/12020
https://bugs.ruby-lang.org/issues/11539
https://bugs.ruby-lang.org/issues/8259
https://bugs.ruby-lang.org/issues/12021
https://bugs.ruby-lang.org/issues/11541


#8 - 12/23/2021 11:43 PM - hsbt (Hiroshi SHIBATA)

- Project changed from 14 to Ruby

#9 - 04/03/2024 03:50 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned
